﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Data.Linq;
using System.Data.Linq.Mapping;
using System.Text;

namespace HeuristicLab.Modeling.SQLiteBackend {
  [Table(Name = "Variable")]
  public class Variable {
    public Variable() {
    }

    public Variable(string name)
      : this() {
      this.name = name;
    }

    private int id;
    [Column(Storage = "id", IsPrimaryKey = true, IsDbGenerated = true)]
    public int Id {
      get { return this.id; }
      private set { this.id = value; }
    }

    private string name;
    [Column(Storage = "name", CanBeNull = false)]
    public string Name {
      get { return this.name; }
      private set { this.name = value; }
    }

    public IEnumerable<Model> ModelsPredictingThisVariable {
      get {
        using (ModelingDataContext ctx = new ModelingDataContext()) {
          var x = from model in ctx.Models
                  where model.TargetVariable == this
                  select model;
          return x.AsEnumerable();
        }
      }
    }

    public IEnumerable<Model> ModelsUsingThisVariable {
      get {
        using (ModelingDataContext ctx = new ModelingDataContext()) {
          var x = from inputVariable in ctx.InputVariables
                  where inputVariable.Variable == this
                  select inputVariable.Model;
          return x.AsEnumerable();
        }
      }
    }
  }
}
